/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package utils;

import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.BufferedReader;
import java.io.Closeable;
import java.io.IOException;
import java.net.URL;

/**
 *
 * Date: 12 Δεκ 2011
 * @author Jason Koukas
 */
public class UtilsIO {

    public static void safelyCloseStream(Closeable c) {
        if (c != null) {
            try {
                c.close();
            } catch (IOException ioe) {
            }
        }
    }
    //Helpful methods to be used by subclasses

    public static String getNextLine(BufferedReader br, boolean ignoreEmpty) throws IOException {
        String line;
        do {
            line = br.readLine();
            if (line != null) { //Doesn't seem to be necessary
                line = line.trim();
            }
            if (ignoreEmpty && "".equals(line)) {
                continue;
            } else {
                break;
            }
        } while (true);
        return line;
    }

    public static URL getResourceURL(String path) {
        return getResourceURL(UtilsIO.class, path);
    }

    public static URL getResourceURL(Class<?> relativeClass, String path) {
        URL urlFile = relativeClass.getResource(path);
        if (urlFile == null) {
            UtilsLogging.log(relativeClass, "Couldn't find file: " + path);
        }
        return urlFile;
    }

    public static Object getSystemClipboard(DataFlavor flavor) {
        Clipboard systemClipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
        if (systemClipboard.isDataFlavorAvailable(flavor)) {
            try {
                return systemClipboard.getData(flavor);
            } catch (UnsupportedFlavorException ufe) {
                UtilsLogging.log(UtilsIO.class, ufe);
            } catch (IOException ioe) {
                UtilsLogging.log(UtilsIO.class, ioe);
            }
        }
        return null;
    }
}
