/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package utils;

import java.awt.Graphics2D;
import java.awt.GraphicsEnvironment;
import java.awt.Image;
import java.awt.image.BufferedImage;
import javax.swing.Icon;
import javax.swing.ImageIcon;

/**
 *
 * Date: 23 Φεβ 2012
 * @author Jason Koukas
 */
public class UtilsImages {

    /**
     * Returns an ImageIcon, or null if the path was invalid.
     */
    public static ImageIcon loadImageIcon(String path) {
        return loadImageIcon(path, null);
    }

    public static ImageIcon loadImageIcon(String path, String description) {
        java.net.URL imgURL = UtilsIO.getResourceURL(path);
        if (imgURL != null) {
            if (description != null) {
                return new ImageIcon(imgURL, description);
            } else {
                return new ImageIcon(imgURL);
            }
        }
        return null;
    }

    public static Image getScaledImage(Image image, int newWidth, int newHeight, int hints) {
        return image.getScaledInstance(newWidth, newHeight, hints);
    }

    public static Image getScaledImage(Image image, int newWidth, int newHeight) {
        return getScaledImage(image, newWidth, newHeight, Image.SCALE_SMOOTH);
    }

    public static ImageIcon getScaledImageIcon(Image image, int width, int height, int hints) {
        return new ImageIcon(getScaledImage(image, width, height, hints));
    }

    public static ImageIcon getScaledImageIcon(Image image, int width, int height) {
        return new ImageIcon(getScaledImage(image, width, height));
    }

    public static ImageIcon getScaledImageIcon(ImageIcon source, int newSizeX, int newSizeY, int hints) {
        return getScaledImageIcon(source.getImage(), newSizeX, newSizeY, hints);
    }

    public static ImageIcon getScaledImageIcon(ImageIcon source, int newSizeX, int newSizeY) {
        return getScaledImageIcon(source.getImage(), newSizeX, newSizeY);
    }

    public static Image iconToImage(Icon icon) {
        if (icon instanceof ImageIcon) {
            return ((ImageIcon) icon).getImage();
        } else {
            BufferedImage image = GraphicsEnvironment.getLocalGraphicsEnvironment().
                    getDefaultScreenDevice().getDefaultConfiguration().createCompatibleImage(icon.getIconWidth(), icon.getIconHeight());
            Graphics2D g = image.createGraphics();
            icon.paintIcon(null, g, 0, 0);
            g.dispose();
            return image;
        }
    }
}
