/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package utils;

import java.awt.Color;
import java.awt.Font;
import javax.swing.BorderFactory;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.border.TitledBorder;
import javax.swing.plaf.FontUIResource;

/**
 *
 * Date: 6 Μαρ 2012
 * @author Jason Koukas
 */
public class UtilsLookAndFeel {

    public static final Color COLOR_BACKGROUND_MAIN = new Color(0xF2F2F2);
    public static final Color COLOR_BACKGROUND_SETTINGS = new Color(0xFFFFFF);
    public static final Color COLOR_LINE = new Color(0x0099FF);
    public static final Color COLOR_TITLES = Color.black; //The Color of the strings in line borders
    //
    public static final Font FONT = new Font("Tahoma", Font.PLAIN, 11); //A custom Font which we use for the field
    public static final Font FONT_TITLES = FONT.deriveFont(Font.BOLD); //A custom Font which we use for the field

    static {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (ClassNotFoundException e) {
            UtilsLogging.log(UtilsLookAndFeel.class, e);
        } catch (InstantiationException e) {
            UtilsLogging.log(UtilsLookAndFeel.class, e);
        } catch (IllegalAccessException e) {
            UtilsLogging.log(UtilsLookAndFeel.class, e);
        } catch (UnsupportedLookAndFeelException e) {
            UtilsLogging.log(UtilsLookAndFeel.class, e);
        }
        setUIGlobalFont(FONT, 1.0f);
        UIManager.put("MenuBar.background", COLOR_BACKGROUND_MAIN);
        UIManager.put("MenuItem.background", COLOR_BACKGROUND_MAIN);
    }

    private static void setUIGlobalFont(Font font) {
        setUIGlobalFont(font, -1);
    }

    private static void setUIGlobalFont(Font font, float fontSizeAnalogy) {
        FontUIResource f = new javax.swing.plaf.FontUIResource(font);
        java.util.Enumeration keys = UIManager.getDefaults().keys();
        while (keys.hasMoreElements()) {
            Object key = keys.nextElement();
            Object value = UIManager.get(key);
            if (value instanceof javax.swing.plaf.FontUIResource) {
                FontUIResource resource;
                if (fontSizeAnalogy > 0) {
                    resource = new FontUIResource(font.deriveFont(((FontUIResource) value).getStyle(), ((FontUIResource) value).getSize() * fontSizeAnalogy));
                } else {
                    resource = f;
                }
                UIManager.put(key, resource);
            }
        }
    }

    public static Font deriveFont(Font font, float fontSizeAnalogy) {
        //return deriveFont(font, font.getStyle(), fontSizeAnalogy);
        return font.deriveFont((float) font.getSize() * fontSizeAnalogy);
    }

    public static Font deriveFont(Font font, int style, float fontSizeAnalogy) {
        return font.deriveFont(style, (float) font.getSize() * fontSizeAnalogy);
    }

    /**
     * Other Helpful Methods
     */
    public static TitledBorder getTitledBorder(String title) {
        return getTitledBorder(title, true, 1);
    }

    public static TitledBorder getTitledBorder(String title, int lineThickness) {
        return getTitledBorder(title, true, lineThickness);
    }

    public static TitledBorder getTitledBorder(String title, boolean titleGaps, int lineThickness) {
        if (titleGaps) {
            if (!title.startsWith(" ")) {
                title = " " + title;
            }
            if (!title.endsWith(" ")) {
                title = title + " ";
            }
        }

        TitledBorder border = BorderFactory.createTitledBorder(BorderFactory.createLineBorder(COLOR_LINE, lineThickness), title);
        border.setTitleFont(FONT_TITLES);
        border.setTitleColor(COLOR_TITLES);
        return border;
    }
}
