/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package utils;

import java.util.StringTokenizer;

/**
 *
 * Date: 27 Μαρ 2012
 * @author Jason Koukas
 */
public class UtilsText {

    public static final String STRING_COLUMN_DELIMITER = ":";
    //
    public static String HTML_OPEN_TAG = "<html>";
    public static String HTML_CLOSE_TAG = "</html>";
    public static String WHITE_SPACE_CHARACTERS = " \n\t\r";

    public static boolean isTextHTML(String text) {
        text = text.toLowerCase();
        return text.startsWith(HTML_OPEN_TAG) && text.endsWith(HTML_CLOSE_TAG);
    }

    public static String getTextNoHTML(String text) {
        return getTextNoHTML(text, false);
    }

    public static String getTextNoHTML(String text, boolean convertWhiteSpacesToSingleSpace) {
        return getTextNoHTML(text, convertWhiteSpacesToSingleSpace, Integer.MAX_VALUE);
    }

    public static String getTextNoHTML(String text, boolean convertWhiteSpacesToSingleSpace, int maxOutputTextLength) {
        StringTokenizer untagger = new StringTokenizer(text, "<>", true);
        text = "";
        int len = 0;
        boolean inTag = false;
        while (untagger.hasMoreTokens()) {
            String tok = untagger.nextToken();
            if (tok.equals("<")) {
                inTag = true;
            } else if (tok.equals(">")) {
                inTag = false;
            } else {
                if (!inTag) {
                    if (convertWhiteSpacesToSingleSpace) {
                        StringTokenizer trimmer = new StringTokenizer(tok, WHITE_SPACE_CHARACTERS); //white character tokenizer
                        while (trimmer.hasMoreTokens()) {
                            tok = trimmer.nextToken() + " ";
                            text += tok;
                            len += tok.length();
                        }
                    } else {
                        text += tok;
                        len += tok.length();
                    }

                    if (maxOutputTextLength >= 0 && len >= maxOutputTextLength) {
                        if (len == maxOutputTextLength) {
                            return text.substring(0, maxOutputTextLength - 1);
                        } else if (len == maxOutputTextLength + 1) {
                            return text.substring(0, maxOutputTextLength);
                        } else {
                            return text.substring(0, maxOutputTextLength) + "...";
                        }
                    }
                }
            }
        }
        return text.trim();
    }
}
