/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package utils.dnd;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.IOException;
import java.io.Serializable;

/**
 *
 * Date: 23 Φεβ 2012
 * @author Jason Koukas
 */
public class TransferableGeneric<E extends Serializable> implements Transferable {

    private DataFlavor[] m_supportedFlavors;
    private E m_transferData;

    public TransferableGeneric(E transferData, DataFlavor[] supportedFlavors) {
        m_transferData = transferData;
        m_supportedFlavors = supportedFlavors;
    }

    public DataFlavor[] getTransferDataFlavors() {
        return m_supportedFlavors;
    }

    public boolean isDataFlavorSupported(DataFlavor flavor) {
        return TransferHandlerCustomExtend.isDataFlavorSupported(flavor, m_supportedFlavors);
    }

    public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException, IOException {
        if (!isDataFlavorSupported(flavor)) {
            throw new UnsupportedFlavorException(flavor);
        }
        return convertToRequestedFlavor(m_transferData, flavor);
    }

    //Method to override
    protected Object convertToRequestedFlavor(E transferData, DataFlavor flavor) {
        return transferData;
    }
}
