/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package utils.io;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.Reader;

/**
 *
 * Date: 2 Φεβ 2012
 * @author Jason Koukas
 */
public class BufferedReaderExtended extends BufferedReader {

    private int m_read;
    private boolean m_hasUnread;
    private String m_lastReadLine;

    public BufferedReaderExtended(Reader in, int sz) {
        super(in, sz);
    }

    public BufferedReaderExtended(Reader in) {
        super(in);
    }

    //If we have unread the last line, still, the "read but unread" line will be returned..
    public String getLastReadLine(){
        return m_lastReadLine;
    }

    public int getLinesRead() {
        return m_read;
    }

    public boolean unreadLastLine() {
        if (m_hasUnread) {
            return false;
        }
        m_hasUnread = true;
        m_read--;
        return true;
    }


    //Last line is considered to be the End of Line
    @Override
    public String readLine() throws IOException {
        if (m_hasUnread) {
            m_hasUnread = false;
            m_read++;
            return m_lastReadLine;
        }
        String ret = super.readLine();
        if (ret != null || m_lastReadLine != null) {
            m_lastReadLine = ret;
            m_read++;
        }
        return ret;
    }
}
