/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package utils.math;

/**
 *
 * Date: 18 Μαρ 2012
 * @author Jason Koukas
 */
public class DoubleLimit extends Number implements Comparable<Double> {

    private double m_value;
    private boolean m_isLimitIncluded;
    private boolean m_isLimitPlus;

    public DoubleLimit(double value) {
        m_value = value;
        m_isLimitIncluded = true;
    }

    public DoubleLimit(double value, boolean isLimitPlus) {
        m_value = value;
        m_isLimitIncluded = false;
        m_isLimitPlus = isLimitPlus;
    }

    public boolean isLimitIncluded() {
        return m_isLimitIncluded;
    }

    public boolean isGreaterThanLimit() {
        return !m_isLimitIncluded && m_isLimitPlus;
    }

    public boolean isSmallerThanLimit() {
        return !m_isLimitIncluded && !m_isLimitPlus;
    }

    @Override
    public int intValue() {
        return (int) m_value;
    }

    @Override
    public long longValue() {
        return (long) m_value;
    }

    @Override
    public float floatValue() {
        return (float) m_value;
    }

    @Override
    public double doubleValue() {
        return m_value;
    }

    public int compareTo(Double d) {
        if (!m_isLimitIncluded && m_value == d) {
            if (m_isLimitPlus) {
                return 1;
            } else {
                return -1;
            }
        }
        return Double.compare(m_value, d);
    }

    public int compareTo(DoubleLimit d) {
        if (!m_isLimitIncluded && m_value == d.doubleValue()) {
            if (m_isLimitPlus == d.m_isLimitPlus) {
                return 0;
            }
            if (m_isLimitPlus) {
                return 1;
            } else {
                return -1;
            }
        }
        return Double.compare(m_value, d.doubleValue());
    }
}
