package utils.ui;

import javax.swing.*;
import javax.swing.text.html.*;
import javax.swing.event.*;
import java.awt.*;
import java.net.URL;
import java.io.*;
import java.net.URI;
import java.net.URISyntaxException;
import utils.UtilsLogging;

public class HTMLViewer extends JPanel {

    //private static final Color BACKGROUND_COLOR = Color.white;
    private JEditorPane m_textPane;

    public HTMLViewer() {
        super();

        m_textPane = new JEditorPane();
        //m_textPane.setBackground(BACKGROUND_COLOR);
        //m_textPane.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createMatteBorder(4, 4, 4, 4,
        //        Color.black), BorderFactory.createMatteBorder(20, 30, 20, 30, Color.white)));
        m_textPane.setEditorKit(new HTMLEditorKit());
        m_textPane.addHyperlinkListener(new HyperlinkListener() {

            public void hyperlinkUpdate(HyperlinkEvent e) {
                URL clickedURL = e.getURL();
                if (e.getEventType().equals(HyperlinkEvent.EventType.ACTIVATED)) {
                    if (Desktop.isDesktopSupported()) {
                        Desktop desktop = Desktop.getDesktop();
                        try {
                            URI uri = clickedURL.toURI();
                            desktop.browse(uri);
                        } catch (IOException ex) {
                            UtilsLogging.log(getClass(), ex);
                        } catch (URISyntaxException ex) {
                            UtilsLogging.log(getClass(), ex);
                        }
                    }

                }
            }
        });
        m_textPane.setEditable(false);

        setLayout(new BorderLayout());
        add(BorderLayout.CENTER, new JScrollPane(m_textPane));

        clearPage();
    }

    public void setPage(URL pageUrl) {
        clearPage();
        try {
            m_textPane.setPage(pageUrl);
        } catch (IOException ioe) {
            UtilsLogging.log(getClass(), ioe);
        }
    }

    public final void clearPage() {
        m_textPane.setDocument(new HTMLDocument());
    }
    //Was for the "about" dialog
//    @Override
//    public void addMouseListener(MouseListener mouseListener) {
//        m_textPane.addMouseListener(mouseListener);
//    }
//
//    @Override
//    public void removeMouseListener(MouseListener mouseListener) {
//        m_textPane.removeMouseListener(mouseListener);
//    }
}
