/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package utils.ui;

import java.awt.BorderLayout;
import java.awt.Component;
import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import utils.UtilsText;

/**
 *
 * Date: 18 Μαρ 2012
 * @author Jason Koukas
 */
public class LabelledWrapper extends JPanel {

    protected JLabel m_wrapperLabel;
    protected Component m_wrapComponent;

    public LabelledWrapper(Component comp, String labelText) {
        this(comp, labelText, null);
    }

    public LabelledWrapper(Component comp, String labelText, String labelToolTip) {
        this(comp, labelText, labelToolTip, JLabel.LEFT);
    }

    public LabelledWrapper(Component comp, String labelText, String labelToolTip, int labelHorizontalAlignment) {
        super(new BorderLayout());
        labelText = labelText.trim();
        boolean isHtml = UtilsText.isTextHTML(labelText);

        if (isHtml) {
            labelText = labelText.substring(0, labelText.length() - UtilsText.HTML_CLOSE_TAG.length()).trim();
        }

        if (!labelText.endsWith(UtilsText.STRING_COLUMN_DELIMITER)) {
            labelText += UtilsText.STRING_COLUMN_DELIMITER;
        }
        if (labelToolTip == null) {
            labelToolTip = labelText.substring(0, labelText.length() - 1);//UtilsText.getTextNoHTML(labelText.substring(0, labelText.length() - 1), true);
        }

        if (isHtml) {
            labelText += UtilsText.HTML_CLOSE_TAG;
        }

        m_wrapComponent = comp;

        m_wrapperLabel = new JLabel(labelText, labelHorizontalAlignment);
        m_wrapperLabel.setToolTipText(labelToolTip);
        m_wrapperLabel.setBorder(BorderFactory.createEmptyBorder(0, 7, 0, 5));

        add(BorderLayout.WEST, m_wrapperLabel);
        add(BorderLayout.CENTER, comp);
    }

    public JLabel getWrapperLabel() {
        return m_wrapperLabel;
    }

    public Component getWrapperComponent() {
        return m_wrapComponent;
    }
}
